osgShadow::ViewDependentShadowMap Class Reference

`#include <ViewDependentShadowMap>`

Inheritance diagram for osgShadow::ViewDependentShadowMap:

## Classes

struct | Frustum
struct | LightData
struct | ShadowData
class | ViewDependentData

## Public Types

typedef std::list< osg::ref_ptr< LightData > > | LightDataList
typedef std::list< osg::ref_ptr< ShadowData > > | ShadowDataList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ViewDependentShadowMap ()
| ViewDependentShadowMap (const ViewDependentShadowMap &vdsm, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgShadow, ViewDependentShadowMap)
virtual void | init ()
virtual void | update (osg::NodeVisitor &nv)
virtual void | cull (osgUtil::CullVisitor &cv)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
virtual void | cleanSceneGraph ()
virtual ViewDependentData * | createViewDependentData (osgUtil::CullVisitor *cv)
ViewDependentData * | getViewDependentData (osgUtil::CullVisitor *cv)
virtual void | createShaders ()
virtual bool | selectActiveLights (osgUtil::CullVisitor *cv, ViewDependentData *vdd) const
virtual osg::Polytope | computeLightViewFrustumPolytope (Frustum &frustum, LightData &positionedLight)
virtual bool | computeShadowCameraSettings (Frustum &frustum, LightData &positionedLight, osg::Matrixd &projectionMatrix, osg::Matrixd &viewMatrix)
virtual bool | adjustPerspectiveShadowMapCameraSettings (osgUtil::RenderStage *renderStage, Frustum &frustum, LightData &positionedLight, osg::Camera *camera)
virtual bool | assignTexGenSettings (osgUtil::CullVisitor *cv, osg::Camera *camera, unsigned int textureUnit, osg::TexGen *texgen)
virtual void | cullShadowReceivingScene (osgUtil::CullVisitor *cv) const
virtual void | cullShadowCastingScene (osgUtil::CullVisitor *cv, osg::Camera *camera) const
virtual osg::StateSet * | selectStateSetForRenderingShadow (ViewDependentData &vdd) const
Public Member Functions inherited from osgShadow::ShadowTechnique
| ShadowTechnique ()
| ShadowTechnique (const ShadowTechnique &es, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | setShadowedScene (ShadowedScene *ss)
ShadowedScene * | getShadowedScene ()
const ShadowedScene * | getShadowedScene () const
virtual void | traverse (osg::NodeVisitor &nv)
virtual void | dirty ()
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::map< osgUtil::CullVisitor *, osg::ref_ptr< ViewDependentData > > | ViewDependentDataMap
typedef std::vector< osg::ref_ptr< osg::Uniform > > | Uniforms

## Protected Member Functions

virtual | ~ViewDependentShadowMap ()
Protected Member Functions inherited from osgShadow::ShadowTechnique
osg::Vec3 | computeOrthogonalVector (const osg::Vec3 &direction) const
virtual | ~ShadowTechnique ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

OpenThreads::Mutex | _viewDependentDataMapMutex
ViewDependentDataMap | _viewDependentDataMap
osg::ref_ptr< osg::StateSet > | _shadowRecievingPlaceholderStateSet
osg::ref_ptr< osg::StateSet > | _shadowCastingStateSet
osg::ref_ptr< osg::PolygonOffset > | _polygonOffset
osg::ref_ptr< osg::Texture2D > | _fallbackBaseTexture
osg::ref_ptr< osg::Texture2D > | _fallbackShadowMapTexture
OpenThreads::Mutex | _accessUniformsAndProgramMutex
Uniforms | _uniforms
osg::ref_ptr< osg::Program > | _program
Protected Attributes inherited from osgShadow::ShadowTechnique
ShadowedScene * | _shadowedScene
bool | _dirty
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

ViewDependentShadowMap provides an base implementation of view dependent shadow mapping techniques.

## Member Typedef Documentation

## LightDataList

typedef std::list< osg::ref_ptr<LightData> > osgShadow::ViewDependentShadowMap::LightDataList

## ShadowDataList

typedef std::list< osg::ref_ptr<ShadowData> > osgShadow::ViewDependentShadowMap::ShadowDataList

## Uniforms

typedef std::vector< osg::ref_ptr<osg::Uniform> > osgShadow::ViewDependentShadowMap::Uniforms

protected

## ViewDependentDataMap

typedef std::map< osgUtil::CullVisitor*, osg::ref_ptr<ViewDependentData> > osgShadow::ViewDependentShadowMap::ViewDependentDataMap

protected

## Constructor & Destructor Documentation

## ViewDependentShadowMap() [1/2]

osgShadow::ViewDependentShadowMap::ViewDependentShadowMap | ( |  | ) |

Referenced by osgShadow::ViewDependentShadowMap::ViewDependentData::getViewDependentShadowMap(), META_Object(), osgShadow::ViewDependentShadowMap::ViewDependentData::ViewDependentData(), and ViewDependentShadowMap().

## ViewDependentShadowMap() [2/2]

osgShadow::ViewDependentShadowMap::ViewDependentShadowMap | ( | const ViewDependentShadowMap & | vdsm,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and ViewDependentShadowMap().

## ~ViewDependentShadowMap()

virtual osgShadow::ViewDependentShadowMap::~ViewDependentShadowMap | ( |  | ) |

protected virtual

## Member Function Documentation

## adjustPerspectiveShadowMapCameraSettings()

virtual bool osgShadow::ViewDependentShadowMap::adjustPerspectiveShadowMapCameraSettings | ( | osgUtil::RenderStage * | renderStage,
|  | Frustum & | frustum,
|  | LightData & | positionedLight,
|  | osg::Camera * | camera )

virtual

## assignTexGenSettings()

virtual bool osgShadow::ViewDependentShadowMap::assignTexGenSettings | ( | osgUtil::CullVisitor * | cv,
|  | osg::Camera * | camera,
|  | unsigned int | textureUnit,
|  | osg::TexGen * | texgen )

virtual

## cleanSceneGraph()

virtual void osgShadow::ViewDependentShadowMap::cleanSceneGraph | ( |  | ) |

virtual

Clean scene graph from any shadow technique specific nodes, state and drawables.

Reimplemented from osgShadow::ShadowTechnique.

## computeLightViewFrustumPolytope()

virtual osg::Polytope osgShadow::ViewDependentShadowMap::computeLightViewFrustumPolytope | ( | Frustum & | frustum,
|  | LightData & | positionedLight )

virtual

## computeShadowCameraSettings()

virtual bool osgShadow::ViewDependentShadowMap::computeShadowCameraSettings | ( | Frustum & | frustum,
|  | LightData & | positionedLight,
|  | osg::Matrixd & | projectionMatrix,
|  | osg::Matrixd & | viewMatrix )

virtual

## createShaders()

virtual void osgShadow::ViewDependentShadowMap::createShaders | ( |  | ) |

virtual

## createViewDependentData()

virtual ViewDependentData * osgShadow::ViewDependentShadowMap::createViewDependentData | ( | osgUtil::CullVisitor * | cv | ) |

virtual

## cull()

virtual void osgShadow::ViewDependentShadowMap::cull | ( | osgUtil::CullVisitor & | cv | ) |

virtual

run the cull traversal of the ShadowedScene and set up the rendering for this ShadowTechnique.

Reimplemented from osgShadow::ShadowTechnique.

## cullShadowCastingScene()

virtual void osgShadow::ViewDependentShadowMap::cullShadowCastingScene | ( | osgUtil::CullVisitor * | cv,
|  | osg::Camera * | camera ) const

virtual

## cullShadowReceivingScene()

virtual void osgShadow::ViewDependentShadowMap::cullShadowReceivingScene | ( | osgUtil::CullVisitor * | cv | ) | const

virtual

## getViewDependentData()

ViewDependentData * osgShadow::ViewDependentShadowMap::getViewDependentData | ( | osgUtil::CullVisitor * | cv | ) |

## init()

virtual void osgShadow::ViewDependentShadowMap::init | ( |  | ) |

virtual

initialize the ShadowedScene and local cached data structures.

Reimplemented from osgShadow::ShadowTechnique.

## META_Object()

osgShadow::ViewDependentShadowMap::META_Object | ( | osgShadow | ,
|  | ViewDependentShadowMap | )

References ViewDependentShadowMap().

## releaseGLObjects()

virtual void osgShadow::ViewDependentShadowMap::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Implements osgShadow::ShadowTechnique.

## resizeGLObjectBuffers()

virtual void osgShadow::ViewDependentShadowMap::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Implements osgShadow::ShadowTechnique.

## selectActiveLights()

virtual bool osgShadow::ViewDependentShadowMap::selectActiveLights | ( | osgUtil::CullVisitor * | cv,
|  | ViewDependentData * | vdd ) const

virtual

## selectStateSetForRenderingShadow()

virtual osg::StateSet * osgShadow::ViewDependentShadowMap::selectStateSetForRenderingShadow | ( | ViewDependentData & | vdd | ) | const

virtual

## update()

virtual void osgShadow::ViewDependentShadowMap::update | ( | osg::NodeVisitor & | nv | ) |

virtual

run the update traversal of the ShadowedScene and update any loca chached data structures.

Reimplemented from osgShadow::ShadowTechnique.

## Member Data Documentation

## _accessUniformsAndProgramMutex

OpenThreads::Mutex osgShadow::ViewDependentShadowMap::_accessUniformsAndProgramMutex

mutable protected

## _fallbackBaseTexture

osg::ref_ptr<osg::Texture2D> osgShadow::ViewDependentShadowMap::_fallbackBaseTexture

protected

## _fallbackShadowMapTexture

osg::ref_ptr<osg::Texture2D> osgShadow::ViewDependentShadowMap::_fallbackShadowMapTexture

protected

## _polygonOffset

osg::ref_ptr<osg::PolygonOffset> osgShadow::ViewDependentShadowMap::_polygonOffset

protected

## _program

osg::ref_ptr<osg::Program> osgShadow::ViewDependentShadowMap::_program

protected

## _shadowCastingStateSet

osg::ref_ptr<osg::StateSet> osgShadow::ViewDependentShadowMap::_shadowCastingStateSet

protected

## _shadowRecievingPlaceholderStateSet

osg::ref_ptr<osg::StateSet> osgShadow::ViewDependentShadowMap::_shadowRecievingPlaceholderStateSet

protected

## _uniforms

Uniforms osgShadow::ViewDependentShadowMap::_uniforms

protected

## _viewDependentDataMap

ViewDependentDataMap osgShadow::ViewDependentShadowMap::_viewDependentDataMap

protected

## _viewDependentDataMapMutex

OpenThreads::Mutex osgShadow::ViewDependentShadowMap::_viewDependentDataMapMutex

mutable protected

The documentation for this class was generated from the following file:

- ViewDependentShadowMap